// view online at: http://rise4fun.com/Dafny/dBwb
// return the index if the value is in a, otherwise return a negative value
method Find(a: array<int>, value: int) returns (index: int) 
  requires a != null
  ensures index >= 0 ==> index < a.Length && a[index] == value
  ensures index < 0 ==> forall k :: 0 <= k < a.Length ==> a[k] != value
{
  index := 0;
  while index < a.Length
    invariant index <= a.Length
    invariant forall k :: 0 <= k < index ==> a[k] != value
  {
    if a[index] == value {
      return;
    }
    index := index + 1;
  }
  index := -1;
}
