// view online at: http://rise4fun.com/Dafny/p7jg
// returns true if the array is sorted
predicate sorted(a: array<int>)
   requires a != null
   reads a
{
   forall j, k :: 0 <= j < k < a.Length ==> a[j] <= a[k]
}

// test method
method m()
{
  var a := new int[3];
  a[0] := 1;  a[1] := 2;  a[2] := 3;
  assert sorted(a);
}
